#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>
#include "dlog.h"

//llevel_t log_level = L_INFO;

int dlog(llevel_t level, const char *fmt, ...)
{
    /*zh@20110817*/
    int off = 0;
    char buf[1024] = "";
    int size = 0;
    va_list va;
    struct tm tm;
    struct timeval tv;

    if (level>dlog_level)
    {
        return 0;
    }

    size = sizeof(buf);

    gettimeofday(&tv, NULL);
    localtime_r(&tv.tv_sec, &tm);

    off = snprintf(buf, size, "<%d> ", level);
    off += strftime(buf+off, size-off, "<%Y-%m-%d %H:%M:%S> ", &tm);
    //off += snprintf(buf+off, size-off, "%11lu.%06ld : ", tv.tv_sec, tv.tv_usec);

    va_start(va, fmt);
    vsnprintf(buf+off, size-off, fmt, va);
    va_end(va);

    fprintf(stdout, "%s", buf);
    return 0;
}
